// simplepodule.cpp : Does all the work.
//
// This example implements a simple podule, both in the sense
// of being _very_ simple and appearing as an Acorn Simple
// Podule.

#include "stdafx.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

#include "IocPodule.h"

// Derive from IocPodule as it does lots of work for us 
class CAdderDevice : public CIocPodule
{
	// All componenets must use this macro
	DECLARE_COMPONENT(CAdderDevice);

	// A couple of registers
	Word op1, op2;

public:
	// The runtime needs a null constructor
	CAdderDevice() {}

	// IocPodule overrides
	virtual void WriteWord(Word address, Word data);
	virtual Word ReadWord(Word address);
	virtual Byte ReadByte(Word address);
};

// This macro enables the device to be instanced from the
// model file
IMPLEMENT_COMPONENT("AdderExample", CAdderDevice);

// RISC OS will read from address 0 to test the podule type.
// We declare ourself as a simple podule
Byte CAdderDevice::ReadByte(Word address)
{
	if (address == 0)
	{
		return 0x9<<3;	// ID of 9
	}
	else
	{
		return 0xff;
	}
}

// Implement two writeable registers at offset 4 and 8
// which form the inputs to our adder
void CAdderDevice::WriteWord(Word address, Word data)
{
	if (address == 4)
	{
		op1 = data;
	}
	else if (address == 8)
	{
		op2 = data;
	}
}

// Implement a readable register at offset 4
// which is the result of the add operation
Word CAdderDevice::ReadWord(Word address)
{
	if (address == 4)
	{
		return op1+op2;
	}
	else
		return 0xffffffff;
}
