// TimerPodule1.h: interface for the CTimerPodule class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TIMERPODULE1_H__C1A65D8B_3C44_4D33_A5BC_98FEFBE56526__INCLUDED_)
#define AFX_TIMERPODULE1_H__C1A65D8B_3C44_4D33_A5BC_98FEFBE56526__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IocPodule.h"
#include "TimerInterface.h"

class CTimerPodule : public CIocPodule  
{
	DECLARE_COMPONENT(CTimerPodule);

	friend class CTimerProperties;

	IEvent		timer;		// timer used to generate interrupts
	IScheduler* scheduler;	// interface to the scheduler
	Word		timer_ticks;// ticks between interrupts

	Byte*		rombase;	// base of rom image
	Word		romsize;	// size of rom image

	Word		rompage;	// rom page register
	Word		ticks;		// timer ticks register
	Byte		int_status; // interrupt status;
	Byte		int_mask;	// interrupt mask

public:
	CTimerPodule();
	virtual ~CTimerPodule();

	// CComponent interface
	virtual BOOL Init();
	virtual BOOL Cleanup();
	virtual BOOL Connect();
	virtual BOOL Disconnect();

	// IocPodule interface
	virtual Byte ReadByte(Word address);
	virtual void WriteByte(Word address, Byte b);
	virtual Word ReadWord(Word address);
	virtual void WriteWord(Word address, Word w);

	// timer callback handler
	int TimerEvent(int overrun);
};

#endif // !defined(AFX_TIMERPODULE1_H__C1A65D8B_3C44_4D33_A5BC_98FEFBE56526__INCLUDED_)
